from virgo_data_analyzer.bench import Bench
from virgo_data_analyzer.package.measurement import (
    Measurement as Package,
)


class Measurement:
    def __init__(self, package: Package):
        self.name = package.metadata.name
        self.description = package.metadata.description
        self.injection_power = package.metadata.injection_power
        self.dark_fringe_power = package.metadata.dark_fringe_power

        self.benches: list[Bench] = []
        for i in range(len(package.benches)):
            bench = package.benches[i]
            mirror = package.mirrors[i]
            movement = (
                bench.metadata.factor_calib * bench.signal
                - mirror.metadata.factor_calib * mirror.signal
            )
            self.benches.append(
                Bench(
                    name=bench.metadata.name,
                    fsc=bench.metadata.fsc,
                    movement=movement,
                )
            )
        self.sensitivity = package.sensitivity
